Name:           pipenv 
Version:        11.9.0
Release:        1%{?dist}
Summary:        The higher level Python packaging tool

License:        MIT
URL:            https://github.com/pypa/pipenv
Source0:        https://github.com/pypa/%{name}/archive/%{version}/%{name}-%{version}.tar.gz

# Unvendor packages that are packaged for Fedora
Patch1:         0001-unvendor-packages.patch 

# Use connection required pytest marker to skip tests, which
# requires an internet connection
Patch2:         0002-add-connection_required-marker.patch

# Pipfile package was moved from vendor directory to patched
# recently, one of the imports is outdated
Patch3:         0003-pipfile-vendor-to-patched.patch

# A couple of tests fails in mock environment, add option
# to skip these using special pytest marker
# TODO fix and propose upstream
Patch4:         0004-rpmfail-pytest-marker.patch

BuildArch:      noarch
 
BuildRequires:  python3-devel
BuildRequires:  python3dist(flake8) >= 3.0.0
BuildRequires:  python3dist(pip) >= 9.0.1
BuildRequires:  python3dist(requests) > 2.18.0
BuildRequires:  python3dist(setuptools)
BuildRequires:  python3dist(certifi)
BuildRequires:  python3dist(virtualenv-clone)
BuildRequires:  python3dist(urllib3) >= 1.21.1
BuildRequires:  python3dist(virtualenv)
BuildRequires:  python3dist(pytest)
BuildRequires:  python3dist(pytest-xdist)
BuildRequires:  python3dist(mock)
BuildRequires:  python3dist(urllib3) >= 1.21.1
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3dist(sphinx-click)
BuildRequires:  python3dist(twine)
BuildRequires:  python3dist(appdirs)
BuildRequires:  python3dist(click)
BuildRequires:  python3dist(colorama)
BuildRequires:  python3dist(docopt)
BuildRequires:  python3dist(iso8601)
BuildRequires:  python3dist(jinja2)
BuildRequires:  python3dist(markupsafe)
BuildRequires:  python3dist(parse)
BuildRequires:  python3dist(semver)
BuildRequires:  python3dist(pexpect)
BuildRequires:  python3dist(pathlib2)
BuildRequires:  python3dist(psutil)
BuildRequires:  python3dist(flask)
BuildRequires:  python3-Levenshtein
BuildRequires:  git 

%{?python_provide:%python_provide python3-%{name}}

Requires:       python3dist(flake8) >= 3.0.0
Requires:       python3dist(pip) >= 9.0.1
Requires:       python3dist(requests) > 2.18.0
Requires:       python3dist(setuptools)
Requires:       python3dist(certifi)
Requires:       python3dist(virtualenv-clone)
Requires:       python3dist(urllib3) >= 1.21.1
Requires:       python3dist(virtualenv)
Requires:       python3dist(appdirs)
Requires:       python3dist(click)
Requires:       python3dist(colorama)
Requires:       python3dist(docopt)
Requires:       python3dist(iso8601)
Requires:       python3dist(jinja2)
Requires:       python3dist(markupsafe)
Requires:       python3dist(parse)
Requires:       python3dist(semver)
Requires:       python3dist(ptyprocess)
Requires:       python3dist(pytoml)
Requires:       python3dist(six)
Requires:       python3dist(pexpect)
Requires:       python3dist(pathlib2)
Requires:       python3dist(psutil)
Requires:       python3-Levenshtein

Provides:       bundled(python3dist(blindspin))
Provides:       bundled(python3dist(click_completion))
Provides:       bundled(python3dist(click_didyoumean))
Provides:       bundled(python3dist(delegator))
Provides:       bundled(python3dist(first))
Provides:       bundled(python3dist(pipdeptree))
Provides:       bundled(python3dist(pipreqs))
Provides:       bundled(python3dist(requirements))
Provides:       bundled(python3dist(shutilwhich))
Provides:       bundled(python3dist(strict_rfc3339))
Provides:       bundled(python3dist(timestamp))
Provides:       bundled(python3dist(yarg))

# The sources contains patched versions of following packages:
Provides:       bundled(python3dist(pew))
Provides:       bundled(python3dist(contoml))
Provides:       bundled(python3dist(crayons))
Provides:       bundled(python3dist(dotenv))
Provides:       bundled(python3dist(notpip))
Provides:       bundled(python3dist(pipfile))
Provides:       bundled(python3dist(piptools))
Provides:       bundled(python3dist(prettytoml))

%description
The officially recommended Python packaging tool that aims to bring
the best of all packaging worlds (bundler, composer, npm, cargo, yarn, etc.)
to the Python world. Windows is a first–class citizen, in our world.
It automatically creates and manages a virtualenv for your projects, 
as well as adds/removes packages from your Pipfile as you install/uninstall
packages. It also generates the ever–important Pipfile.lock, 
which is used to produce deterministic builds.

%package -n %{name}-doc
Summary:        Pipenv documentation
%description -n %{name}-doc
Documentation for Pipenv

%prep
%autosetup -p1 -n %{name}-%{version}

%build
%py3_build
# generate html docs
sphinx-build-3 docs html
rm -rf html/.{doctrees,buildinfo}

%install
%py3_install

%check
export PATH=$PATH:%{buildroot}%{_bindir}
export PYTHONPATH=$PYTHONPATH:%{buildroot}%{python3_sitelib}
export PYPI_VENDOR_DIR="$(pwd)/tests/pypi/"
pytest-3 -v -n auto -m "not rpmfail" tests

%files
%license LICENSE
%doc README.rst
%{_bindir}/pipenv
%{_bindir}/pipenv-resolver
%{_bindir}/pewtwo
%{python3_sitelib}/%{name}
%{python3_sitelib}/%{name}-%{version}-py?.?.egg-info

%files -n %{name}-doc
%doc html
%license LICENSE

%changelog
* Wed Dec 20 2017 Michal Cyprian <mcyprian@redhat.com> - 9.0.1-1
- Initial package.
